import { ClrDayOfWeek } from '../interfaces/day-of-week.interface';
/**
 * This service extracts the Angular CLDR data needed by the datepicker.
 */
export declare class LocaleHelperService {
    locale: string;
    constructor(locale: string);
    private _firstDayOfWeek;
    private _localeDays;
    private _localeMonthsAbbreviated;
    private _localeMonthsWide;
    private _localeDateFormat;
    readonly firstDayOfWeek: number;
    readonly localeDays: ReadonlyArray<ClrDayOfWeek>;
    readonly localeDaysNarrow: ReadonlyArray<string>;
    readonly localeMonthsAbbreviated: ReadonlyArray<string>;
    readonly localeMonthsWide: ReadonlyArray<string>;
    readonly localeDateFormat: string;
    /**
     * Initializes the locale data.
     */
    private initializeLocaleData;
    /**
     * Initialize day names based on the locale.
     * eg: [{day: Sunday, narrow: S}, {day: Monday, narrow: M}...] for en-US.
     */
    private initializeLocaleDays;
    /**
     * Initializes the array of month names in the TranslationWidth.Abbreviated format.
     * e.g. `[Jan, Feb, ...]` for en-US
     */
    private initializeLocaleMonthsAbbreviated;
    /**
     * Initializes the array of month names in the TranslationWidth.Wide format.
     * e.g. `[January, February, ...]` for en-US
     */
    private initializeLocaleMonthsWide;
    /**
     * Initializes the first day of the week based on the locale.
     */
    private initializeFirstDayOfWeek;
    private initializeLocaleDateFormat;
}
