import { AfterContentInit, ComponentFactoryResolver, ElementRef, EventEmitter, Injector, OnDestroy, ViewContainerRef } from '@angular/core';
import { ClrDragEvent } from '../drag-event';
import { ClrIfDragged } from '../if-dragged';
import { DragEventListenerService } from '../providers/drag-event-listener.service';
import { DragHandleRegistrarService } from '../providers/drag-handle-registrar.service';
import { DraggableSnapshotService } from '../providers/draggable-snapshot.service';
import { GlobalDragModeService } from '../providers/global-drag-mode.service';
export declare class ClrDraggable<T> implements AfterContentInit, OnDestroy {
    private el;
    private dragEventListener;
    private dragHandleRegistrar;
    private viewContainerRef;
    private cfr;
    private injector;
    private draggableSnapshot;
    private globalDragMode;
    private draggableEl;
    private subscriptions;
    private componentFactory;
    dragOn: boolean;
    constructor(el: ElementRef, dragEventListener: DragEventListenerService<T>, dragHandleRegistrar: DragHandleRegistrarService<T>, viewContainerRef: ViewContainerRef, cfr: ComponentFactoryResolver, injector: Injector, draggableSnapshot: DraggableSnapshotService<T>, globalDragMode: GlobalDragModeService);
    customGhost: ClrIfDragged<T>;
    dataTransfer: T;
    group: string | string[];
    private createDefaultGhost;
    private destroyDefaultGhost;
    dragStartEmitter: EventEmitter<ClrDragEvent<T>>;
    dragMoveEmitter: EventEmitter<ClrDragEvent<T>>;
    dragEndEmitter: EventEmitter<ClrDragEvent<T>>;
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
}
